<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Deserialization Flavors"><meta name="keywords" content="rust, rustlang, rust-lang, de_flavors"><title>postcard::de_flavors - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module de_flavors</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#traits">Traits</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">postcard</a>::<wbr><a class="mod" href="#">de_flavors</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/postcard/de/flavors.rs.html#1-282">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><h2 id="deserialization-flavors"><a href="#deserialization-flavors">Deserialization Flavors</a></h2>
<p>“Flavors” in <code>postcard</code> are used as modifiers to the serialization or deserialization
process. Flavors typically modify one or both of the following:</p>
<ol>
<li>The source medium of the deserialization, e.g. whether the data is serialized from a <code>[u8]</code> slice, or some other container</li>
<li>The format of the deserialization, such as if the original data is encoded in a COBS format, contains a CRC32 checksum
appended to the message, etc.</li>
</ol>
<p>Flavors are implemented using the <a href="trait.Flavor.html" title="Flavor"><code>Flavor</code></a> trait, which acts as a “middleware” for retrieving the bytes before they
are passed to <code>serde</code> for deserialization</p>
<p>Multiple flavors may be combined to obtain a desired combination of behavior and storage.
When flavors are combined, it is expected that the storage flavor (such as <a href="struct.Slice.html" title="Slice"><code>Slice</code></a>) is the innermost flavor.</p>
<p>Custom flavors may be defined by users of the <code>postcard</code> crate, however some commonly useful flavors have been provided in
this module. If you think your custom flavor would be useful to others, PRs adding flavors are very welcome!</p>
<h3 id="usability"><a href="#usability">Usability</a></h3>
<p>Flavors may not always be convenient to use directly, as they may expose some implementation details of how the
inner workings of the flavor behaves. It is typical to provide a convenience method for using a flavor, to prevent
the user from having to specify generic parameters, setting correct initialization values, or handling the output of
the flavor correctly. See <code>postcard::from_bytes()</code> for an example of this.</p>
<h3 id="when-to-use-multiple-flavors"><a href="#when-to-use-multiple-flavors">When to use (multiple) flavors</a></h3>
<p>Combining flavors are nice for convenience, as they perform potentially multiple steps of
serialization at one time.</p>
<p>This can often be more memory efficient, as intermediate buffers are not typically required.</p>
<h3 id="when-not-to-use-multiple-flavors"><a href="#when-not-to-use-multiple-flavors">When NOT to use (multiple) flavors</a></h3>
<p>The downside of passing deserialization through multiple steps is that it is typically slower than
performing each step serially. Said simply, “cobs decoding while deserializing” is often slower
than “cobs decode then deserialize”, due to the ability to handle longer “runs” of data in each
stage. The downside is that if these stages can not be performed in-place on the buffer, you
will need additional buffers for each stage.</p>
<p>Additionally, deserializating flavors can be more restrictive or difficult to work with than
serialization flavors, as deserialization may require that the deserialized types borrow some
portion of the original message.</p>
<h3 id="examples"><a href="#examples">Examples</a></h3><h4 id="using-a-single-flavor"><a href="#using-a-single-flavor">Using a single flavor</a></h4>
<p>In the first example, we use the <code>Slice</code> flavor, to retrieve the serialized output from a <code>[u8]</code> slice.
No other modification is made to the serialization process.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">postcard</span>::{
    <span class="ident">de_flavors::Slice</span>,
    <span class="ident">Deserializer</span>,
};
<span class="kw">use</span> <span class="ident">serde::Deserialize</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Deserialize</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">struct</span> <span class="ident">Tup</span>(<span class="ident">u8</span>, <span class="ident">u8</span>, <span class="ident">u8</span>);

<span class="kw">let</span> <span class="ident">msg</span> <span class="op">=</span> [<span class="number">0x04</span>, <span class="number">0x00</span>, <span class="number">0x04</span>, <span class="number">0x01</span>, <span class="number">0x02</span>, <span class="number">0x03</span>];
<span class="kw">let</span> <span class="ident">slice</span> <span class="op">=</span> <span class="ident">Slice::new</span>(<span class="kw-2">&amp;</span><span class="ident">msg</span>);
<span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">deserializer</span> <span class="op">=</span> <span class="ident">Deserializer::from_flavor</span>(<span class="ident">slice</span>);
<span class="kw">let</span> <span class="ident">t</span> <span class="op">=</span> <span class="ident">Tup::deserialize</span>(<span class="kw-2">&amp;mut</span> <span class="ident">deserializer</span>).<span class="ident">unwrap</span>();
<span class="macro">assert_eq!</span>(<span class="ident">t</span>, <span class="ident">Tup</span>(<span class="number">4</span>, <span class="number">0</span>, <span class="number">4</span>));
<span class="kw">let</span> <span class="ident">remainder</span> <span class="op">=</span> <span class="ident">deserializer</span>.<span class="ident">finalize</span>().<span class="ident">unwrap</span>();
<span class="macro">assert_eq!</span>(<span class="ident">remainder</span>, <span class="kw-2">&amp;</span>[<span class="number">1</span>, <span class="number">2</span>, <span class="number">3</span>]);</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Slice.html" title="postcard::de_flavors::Slice struct">Slice</a></div><div class="item-right docblock-short"><p>A simple <a href="trait.Flavor.html" title="Flavor"><code>Flavor</code></a> representing the deserialization from a borrowed slice</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Flavor.html" title="postcard::de_flavors::Flavor trait">Flavor</a></div><div class="item-right docblock-short"><p>The deserialization Flavor trait</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>